
// MusicStudio.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "afxwinappex.h"
#include "MusicStudio.h"
#include "MainFrm.h"

#include "ChildFrm.h"
#include "MusicStudioDoc.h"
#include "MusicStudioView.h"
#include "Configuration.h"
#include "../RESID-FP/trunk/sidplay-2.0.9/src/audio/mmsystem/ExternalSystem.h"

#include "crtDbg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMusicStudioApp

BEGIN_MESSAGE_MAP(CMusicStudioApp, CWinAppEx)
	ON_COMMAND(ID_APP_ABOUT, &CMusicStudioApp::OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, &CWinAppEx::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CWinAppEx::OnFileOpen)
	ON_COMMAND(ID_HELP_CONFIGURATION, &CMusicStudioApp::OnHelpConfiguration)
	ON_COMMAND(ID_HELP_CONFIGURATION32777, &CMusicStudioApp::OnHelpConfiguration)
END_MESSAGE_MAP()


// CMusicStudioApp construction

CMusicStudioApp::CMusicStudioApp()
{
	_CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) | _CRTDBG_CHECK_ALWAYS_DF);

	m_bHiColorIcons = TRUE;

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

// The one and only CMusicStudioApp object

CMusicStudioApp theApp;


// CMusicStudioApp initialization

BOOL CMusicStudioApp::InitInstance()
{
	// Detect where ACME is and set the current directory if needed
	FILE *fp = fopen("..\\..\\acme.exe","rb");
	if (fp)
	{
		fclose(fp);
	}
	else
	{
		LPWSTR str = GetCommandLineW();
		int argc;
		LPWSTR *argv;
		argv = CommandLineToArgvW(str,&argc);
		CStringW path = argv[0];
		LocalFree(argv);

		do
		{
			int pos = path.ReverseFind('\\');
			if (pos >= 0)
			{
				path.Delete(pos,path.GetLength());
			}
			SetCurrentDirectoryW(path);

			fp = fopen("..\\..\\acme.exe","rb");
		} while (!fp && path.GetLength());

		if (fp)
		{
			fclose(fp);
		}
		else
		{
			// MPi: TODO: Convert all these message boxes to use proper string resources
			MessageBox(0,_T("Could not find the ACME tool, so music files cannot be played or exported."),_T("Error"),MB_OK);
		}
	}
	GetCurrentDirectory(2048,mCurrentDirectory);

	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinAppEx::InitInstance();

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need

	// Change the registry key under which our settings are stored
	SetRegistryKey(_T("Element 114 Software"));
	LoadStdProfileSettings(4);  // Load standard INI file options (including MRU)

	gSoftViewRefreshTime = GetProfileInt(CONFIG_NAME,_T("ViewRefreshTime"),100);
	gSoftFrequency = GetProfileInt(CONFIG_NAME,_T("Frequency"),44100);
	gSoftMAXBUFBLOCKS = GetProfileInt(CONFIG_NAME,_T("MAXBUFBLOCKS"),3);
	gSoftBufSizeDivisor = GetProfileInt(CONFIG_NAME,_T("BufSizeDivisor"),1);

	InitContextMenuManager();

	InitKeyboardManager();

	InitTooltipManager();
	CMFCToolTipInfo ttParams;
	ttParams.m_bVislManagerTheme = TRUE;
	theApp.GetTooltipManager()->SetTooltipParams(AFX_TOOLTIP_TYPE_ALL,
		RUNTIME_CLASS(CMFCToolTipCtrl), &ttParams);

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(IDR_MusicStudioTYPE,
		RUNTIME_CLASS(CMusicStudioDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CMusicStudioView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame || !pMainFrame->LoadFrame(IDR_MAINFRAME))
	{
		delete pMainFrame;
		return FALSE;
	}
	m_pMainWnd = pMainFrame;
	// call DragAcceptFiles only if there's a suffix
	//  In an MDI app, this should occur immediately after setting m_pMainWnd
	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	// Stop the window from opening with a new file when a blank window was needed.
	cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;
	ParseCommandLine(cmdInfo);


	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// App command to run the dialog
void CMusicStudioApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

// CMusicStudioApp customization load/save methods

void CMusicStudioApp::PreLoadState()
{
	BOOL bNameValid;
	CString strName;
	bNameValid = strName.LoadString(IDS_EDIT_MENU);
	ASSERT(bNameValid);
	GetContextMenuManager()->AddMenu(strName, IDR_POPUP_EDIT);
}

void CMusicStudioApp::LoadCustomState()
{
}

void CMusicStudioApp::SaveCustomState()
{
}

// CMusicStudioApp message handlers




void CMusicStudioApp::OnHelpConfiguration()
{
	CConfiguration dlg;

	dlg.mFrequency = gSoftFrequency;
	dlg.mViewRefreshFPS = 1000 / gSoftViewRefreshTime;
	dlg.mBufferSize = 11 - gSoftBufSizeDivisor;
	dlg.mNumBuffers = gSoftMAXBUFBLOCKS;

	INT_PTR ret = dlg.DoModal();

	if (ret == IDOK)
	{
		gSoftFrequency = dlg.mFrequency;
		gSoftViewRefreshTime = 1000 / dlg.mViewRefreshFPS;
		gSoftBufSizeDivisor = 11 - dlg.mBufferSize;
		gSoftMAXBUFBLOCKS = dlg.mNumBuffers;

		WriteProfileInt(CONFIG_NAME,_T("ViewRefreshTime"),gSoftViewRefreshTime);
		WriteProfileInt(CONFIG_NAME,_T("Frequency"),gSoftFrequency);
		WriteProfileInt(CONFIG_NAME,_T("MAXBUFBLOCKS"),gSoftMAXBUFBLOCKS);
		WriteProfileInt(CONFIG_NAME,_T("BufSizeDivisor"),gSoftBufSizeDivisor);
	}
}
